<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfKeyValueOfstringanyType ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfKeyValueOfstringanyType
 * @subpackage Arrays
 */
class ArrayOfKeyValueOfstringanyType extends AbstractStructArrayBase
{
    /**
     * The KeyValueOfstringanyType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \patest\StructType\KeyValueOfstringanyType[]
     */
    public $KeyValueOfstringanyType;
    /**
     * Constructor method for ArrayOfKeyValueOfstringanyType
     * @uses ArrayOfKeyValueOfstringanyType::setKeyValueOfstringanyType()
     * @param \patest\StructType\KeyValueOfstringanyType[] $keyValueOfstringanyType
     */
    public function __construct(array $keyValueOfstringanyType = array())
    {
        $this
            ->setKeyValueOfstringanyType($keyValueOfstringanyType);
    }
    /**
     * Get KeyValueOfstringanyType value
     * @return \patest\StructType\KeyValueOfstringanyType[]|null
     */
    public function getKeyValueOfstringanyType()
    {
        return $this->KeyValueOfstringanyType;
    }
    /**
     * This method is responsible for validating the values passed to the setKeyValueOfstringanyType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setKeyValueOfstringanyType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateKeyValueOfstringanyTypeForArrayConstraintsFromSetKeyValueOfstringanyType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfKeyValueOfstringanyTypeKeyValueOfstringanyTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfKeyValueOfstringanyTypeKeyValueOfstringanyTypeItem instanceof \patest\StructType\KeyValueOfstringanyType) {
                $invalidValues[] = is_object($arrayOfKeyValueOfstringanyTypeKeyValueOfstringanyTypeItem) ? get_class($arrayOfKeyValueOfstringanyTypeKeyValueOfstringanyTypeItem) : sprintf('%s(%s)', gettype($arrayOfKeyValueOfstringanyTypeKeyValueOfstringanyTypeItem), var_export($arrayOfKeyValueOfstringanyTypeKeyValueOfstringanyTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The KeyValueOfstringanyType property can only contain items of type \patest\StructType\KeyValueOfstringanyType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set KeyValueOfstringanyType value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\KeyValueOfstringanyType[] $keyValueOfstringanyType
     * @return \patest\ArrayType\ArrayOfKeyValueOfstringanyType
     */
    public function setKeyValueOfstringanyType(array $keyValueOfstringanyType = array())
    {
        // validation for constraint: array
        if ('' !== ($keyValueOfstringanyTypeArrayErrorMessage = self::validateKeyValueOfstringanyTypeForArrayConstraintsFromSetKeyValueOfstringanyType($keyValueOfstringanyType))) {
            throw new \InvalidArgumentException($keyValueOfstringanyTypeArrayErrorMessage, __LINE__);
        }
        $this->KeyValueOfstringanyType = $keyValueOfstringanyType;
        return $this;
    }
    /**
     * Add item to KeyValueOfstringanyType value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\KeyValueOfstringanyType $item
     * @return \patest\ArrayType\ArrayOfKeyValueOfstringanyType
     */
    public function addToKeyValueOfstringanyType(\patest\StructType\KeyValueOfstringanyType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\KeyValueOfstringanyType) {
            throw new \InvalidArgumentException(sprintf('The KeyValueOfstringanyType property can only contain items of type \patest\StructType\KeyValueOfstringanyType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->KeyValueOfstringanyType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\KeyValueOfstringanyType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\KeyValueOfstringanyType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\KeyValueOfstringanyType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\KeyValueOfstringanyType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\KeyValueOfstringanyType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string KeyValueOfstringanyType
     */
    public function getAttributeName()
    {
        return 'KeyValueOfstringanyType';
    }
}
